/////////////////////////////////////////////////////////////////////////
// $Id: resolve32.cc,v 1.8 2002/09/19 19:17:20 kevinlawton Exp $
/////////////////////////////////////////////////////////////////////////
//
//  Copyright (C) 2001  MandrakeSoft S.A.
//
//    MandrakeSoft S.A.
//    43, rue d'Aboukir
//    75002 Paris - France
//    http://www.linux-mandrake.com/
//    http://www.mandrakesoft.com/
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA





#define NEED_CPU_REG_SHORTCUTS 1
#include "bochs.h"
#define LOG_THIS BX_CPU_THIS_PTR




  void
BX_CPU_C::Resolve32Mod0Rm0(bxInstruction_c *i)
{
  RMAddr(i) = EAX;
  BX_CPU_THIS_PTR RMAddr_integrity = EAX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(0);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod0Rm0", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod0Rm1(bxInstruction_c *i)
{
  RMAddr(i) = ECX;
  BX_CPU_THIS_PTR RMAddr_integrity = ECX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(1);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod0Rm1", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod0Rm2(bxInstruction_c *i)
{
  RMAddr(i) = EDX;
  BX_CPU_THIS_PTR RMAddr_integrity = EDX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(2);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod0Rm2", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod0Rm3(bxInstruction_c *i)
{
  RMAddr(i) = EBX;
  BX_CPU_THIS_PTR RMAddr_integrity = EBX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(3);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod0Rm3", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod0Rm5(bxInstruction_c *i)
{
  RMAddr(i) = i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = 0xff;
}
  void
BX_CPU_C::Resolve32Mod0Rm6(bxInstruction_c *i)
{
  RMAddr(i) = ESI;
  BX_CPU_THIS_PTR RMAddr_integrity = ESI_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(6);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod0Rm5", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod0Rm7(bxInstruction_c *i)
{
  RMAddr(i) = EDI;
  BX_CPU_THIS_PTR RMAddr_integrity = EDI_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(7);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod0Rm7", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif

}


  void
BX_CPU_C::Resolve32Mod1or2Rm0(bxInstruction_c *i)
{
  RMAddr(i) = EAX + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = EAX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(0);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod1or2Rm0", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod1or2Rm1(bxInstruction_c *i)
{
  RMAddr(i) = ECX + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = ECX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(1);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod1or2Rm1", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod1or2Rm2(bxInstruction_c *i)
{
  RMAddr(i) = EDX + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = EDX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(2);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod1or2Rm2", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod1or2Rm3(bxInstruction_c *i)
{
  RMAddr(i) = EBX + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = EBX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(3);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod1or2Rm3", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod1or2Rm5(bxInstruction_c *i)
{
  RMAddr(i) = EBP + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = EBP_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(5);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod1or2Rm5", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod1or2Rm6(bxInstruction_c *i)
{
  RMAddr(i) = ESI + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = ESI_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(6);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod1or2Rm6", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod1or2Rm7(bxInstruction_c *i)
{
  RMAddr(i) = EDI + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = EDI_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr;
  	RMExpr = (Expression *) MakeNewQuadReg(7);
	if (!EffectivelyNull(RMExpr))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr, NULL, "ADDRESS_Resolve32Mod1or2Rm7", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}


  void
BX_CPU_C::Resolve32Mod0Base0(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = EAX + scaled_index;
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(EAX_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2;
  	RMExpr1 = (Expression *) MakeNewQuadReg(0);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2, "SIBADDRESS_Resolve32Mod0Base0", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod0Base1(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = ECX + scaled_index;
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(ECX_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2;
  	RMExpr1 = (Expression *) MakeNewQuadReg(1);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2, "SIBADDRESS_Resolve32Mod0Base1", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod0Base2(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = EDX + scaled_index;
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(EDX_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2;
  	RMExpr1 = (Expression *) MakeNewQuadReg(2);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2, "SIBADDRESS_Resolve32Mod0Base2", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod0Base3(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = EBX + scaled_index;
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(EBX_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2;
  	RMExpr1 = (Expression *) MakeNewQuadReg(3);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2, "SIBADDRESS_Resolve32Mod0Base3", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod0Base4(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = ESP + scaled_index;
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(ESP_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2;
  	RMExpr1 = (Expression *) MakeNewQuadReg(4);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2, "SIBADDRESS_Resolve32Mod0Base4", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod0Base5(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = i->displ32u() + scaled_index;
  BX_CPU_THIS_PTR RMAddr_integrity = BX_READ_32BIT_INTEGRITY(i->sibIndex());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2;
	MakeNewQuadConstant(i->displ32u(), RMExpr1)
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2, "SIBADDRESS_Resolve32Mod0Base5", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}

  void
BX_CPU_C::Resolve32Mod0Base6(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = ESI + scaled_index;
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(ESI_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2;
  	RMExpr1 = (Expression *) MakeNewQuadReg(6);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2, "SIBADDRESS_Resolve32Mod0Base6", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}

  void
BX_CPU_C::Resolve32Mod0Base7(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = EDI + scaled_index;
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(EDI_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2;
  	RMExpr1 = (Expression *) MakeNewQuadReg(7);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2, "SIBADDRESS_Resolve32Mod0Base7", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}




  void
BX_CPU_C::Resolve32Mod1or2Base0(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = EAX + scaled_index + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(EAX_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2, *RMExpr3, *RMExpr2And3;
  	RMExpr1 = (Expression *) MakeNewQuadReg(0);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	MakeNewQuadConstant(i->displ32u(), RMExpr3);
	RMExpr2And3 = (Expression *) new Operation(RMExpr2, RMExpr3, "SUM_FOR_Resolve32Mod1or2Base0");
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2And3))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2And3, "SIBADDRESS_Resolve32Mod1or2Base0", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}

  void
BX_CPU_C::Resolve32Mod1or2Base1(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = ECX + scaled_index + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(ECX_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2, *RMExpr3, *RMExpr2And3;
  	RMExpr1 = (Expression *) MakeNewQuadReg(1);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	MakeNewQuadConstant(i->displ32u(), RMExpr3);
	RMExpr2And3 = (Expression *) new Operation(RMExpr2, RMExpr3, "SUM_FOR_Resolve32Mod1or2Base1");
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2And3))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2And3, "SIBADDRESS_Resolve32Mod1or2Base1", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}

  void
BX_CPU_C::Resolve32Mod1or2Base2(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = EDX + scaled_index + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(EDX_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2, *RMExpr3, *RMExpr2And3;
  	RMExpr1 = (Expression *) MakeNewQuadReg(2);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	MakeNewQuadConstant(i->displ32u(), RMExpr3);
	RMExpr2And3 = (Expression *) new Operation(RMExpr2, RMExpr3, "SUM_FOR_Resolve32Mod1or2Base2");
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2And3))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2And3, "SIBADDRESS_Resolve32Mod1or2Base2", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
  void
BX_CPU_C::Resolve32Mod1or2Base3(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = EBX + scaled_index + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(EBX_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2, *RMExpr3, *RMExpr2And3;
  	RMExpr1 = (Expression *) MakeNewQuadReg(3);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	MakeNewQuadConstant(i->displ32u(), RMExpr3);
	RMExpr2And3 = (Expression *) new Operation(RMExpr2, RMExpr3, "SUM_FOR_Resolve32Mod1or2Base3");
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2And3))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2And3, "SIBADDRESS_Resolve32Mod1or2Base3", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}

  void
BX_CPU_C::Resolve32Mod1or2Base4(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = ESP + scaled_index + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(ESP_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2, *RMExpr3, *RMExpr2And3;
  	RMExpr1 = (Expression *) MakeNewQuadReg(4);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	MakeNewQuadConstant(i->displ32u(), RMExpr3);
	RMExpr2And3 = (Expression *) new Operation(RMExpr2, RMExpr3, "SUM_FOR_Resolve32Mod1or2Base4");
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2And3))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2And3, "SIBADDRESS_Resolve32Mod1or2Base4", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif

}
  void
BX_CPU_C::Resolve32Mod1or2Base5(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = EBP + scaled_index + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(EBP_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2, *RMExpr3, *RMExpr2And3;
  	RMExpr1 = (Expression *) MakeNewQuadReg(5);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	MakeNewQuadConstant(i->displ32u(), RMExpr3);
	RMExpr2And3 = (Expression *) new Operation(RMExpr2, RMExpr3, "SUM_FOR_Resolve32Mod1or2Base5");
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2And3))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2And3, "SIBADDRESS_Resolve32Mod1or2Base5", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}

  void
BX_CPU_C::Resolve32Mod1or2Base6(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = ESI + scaled_index + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(ESI_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2, *RMExpr3, *RMExpr2And3;
  	RMExpr1 = (Expression *) MakeNewQuadReg(6);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	MakeNewQuadConstant(i->displ32u(), RMExpr3);
	RMExpr2And3 = (Expression *) new Operation(RMExpr2, RMExpr3, "SUM_FOR_Resolve32Mod1or2Base6");
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2And3))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2And3, "SIBADDRESS_Resolve32Mod1or2Base6", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}

  void
BX_CPU_C::Resolve32Mod1or2Base7(bxInstruction_c *i)
{
  Bit32u scaled_index;

  if (i->sibIndex() != 4)
    scaled_index = BX_READ_32BIT_REG(i->sibIndex()) << i->sibScale();
  else
    scaled_index = 0;
  RMAddr(i) = EDI + scaled_index + i->displ32u();
  BX_CPU_THIS_PTR RMAddr_integrity = low_water_mark(EDI_INTEGRITY, BX_READ_32BIT_INTEGRITY(i->sibIndex()), INTEG_DOUBLE, INTEG_DOUBLE);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	BX_CPU_THIS_PTR RMAddr_expression = NULL;
  	Expression *RMExpr1, *RMExpr2, *RMExpr3, *RMExpr2And3;
  	RMExpr1 = (Expression *) MakeNewQuadReg(7);
  	if (i->sibIndex() != 4)
		RMExpr2 = (Expression *) MakeNewQuadReg(i->sibIndex());
	else
		RMExpr2 = NULL;
	MakeNewQuadConstant(i->displ32u(), RMExpr3);
	RMExpr2And3 = (Expression *) new Operation(RMExpr2, RMExpr3, "SUM_FOR_Resolve32Mod1or2Base7");
	if (!EffectivelyNull(RMExpr1) || !EffectivelyNull(RMExpr2And3))
	{
		Expression *RMPred = (Expression *) new Predicate(RMExpr1, RMExpr2And3, "SIBADDRESS_Resolve32Mod1or2Base7", EIP, BX_CPU_THIS_PTR cr3, 0, BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl);
		TheLabels.AddPredicate(RMPred);
		BX_CPU_THIS_PTR RMAddr_expression = RMPred;
	}
  }
#endif
}
